VERSION 5.00
Begin VB.Form frmRecorder 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "TrickSound2 test capture"
   ClientHeight    =   3495
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   5025
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3495
   ScaleWidth      =   5025
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox cmdPlayback 
      Caption         =   "u"
      BeginProperty Font 
         Name            =   "Wingdings 3"
         Size            =   11.25
         Charset         =   2
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   675
      Left            =   1980
      Style           =   1  'Graphical
      TabIndex        =   3
      Top             =   2700
      Width           =   675
   End
   Begin VB.CheckBox cmdRecording 
      Caption         =   "n"
      BeginProperty Font 
         Name            =   "Webdings"
         Size            =   11.25
         Charset         =   2
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   675
      Left            =   1260
      Style           =   1  'Graphical
      TabIndex        =   2
      Top             =   2700
      Width           =   675
   End
   Begin VB.ComboBox cboCaptureDevices 
      Height          =   315
      Left            =   60
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   2280
      Width           =   4815
   End
   Begin VB.PictureBox picWaveform 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      ForeColor       =   &H0000FF00&
      Height          =   2055
      Left            =   60
      ScaleHeight     =   133
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   321
      TabIndex        =   0
      Top             =   120
      Width           =   4875
   End
   Begin Recorder.ctlKnob knbPitch 
      Height          =   675
      Left            =   2640
      TabIndex        =   4
      ToolTipText     =   "Pitch"
      Top             =   2700
      Width           =   795
      _ExtentX        =   1402
      _ExtentY        =   1191
      Min             =   0.5
      Max             =   2
      Value           =   1
      SmallChange     =   0.001
      LargeChange     =   0.01
   End
End
Attribute VB_Name = "frmRecorder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const PBK_NUMOFCHANNELS As Long = 2
Private Const PBK_SAMPLERATE    As Long = 44100
Private Const PBK_BITNESS       As Long = 16
Private Const PBK_BUFFERSIZEMS  As Single = 0.3

Dim WithEvents tSound   As clsTrickSound2
Attribute tSound.VB_VarHelpID = -1

Dim IsRecording As Boolean
Dim IsPlayback  As Boolean
Dim capBuffer() As Integer
Dim capCount    As Long
Dim plyIndex    As Long

Private Sub cmdPlayback_Click()

    On Error GoTo error_handler
    
    If tSound.IsUnavailable Then
    
        ' // Unitialize previous capture session
        tSound.Uninitialize

        cmdRecording.Enabled = True
        cboCaptureDevices.Enabled = True
        IsPlayback = False
        
        Exit Sub
        
    End If

    ' // Initialize new
    If Not tSound.InitPlayback(PBK_NUMOFCHANNELS, _
                                PBK_SAMPLERATE * knbPitch.value, PBK_BITNESS, _
                                PBK_BUFFERSIZEMS * PBK_SAMPLERATE) Then
        MsgBox "Error of playback initialization", vbCritical
    End If
    
    tSound.StartProcess
    
    cboCaptureDevices.Enabled = False
    cmdRecording.Enabled = False
    IsPlayback = True
    plyIndex = 0
    
    Exit Sub
    
error_handler:
    
    MsgBox "Error has occured " & err.Number
    
End Sub

Private Sub cmdRecording_Click()

    On Error GoTo error_handler
    
    If tSound.IsUnavailable Then
    
        ' // Unitialize previous capture session
        tSound.Uninitialize
        
        cmdRecording.Caption = "n"
        cmdRecording.ForeColor = vbRed
        cmdPlayback.Enabled = True
        cboCaptureDevices.Enabled = True
        IsRecording = False
        
        Exit Sub
        
    End If

    ' // Initialize new
    If Not tSound.InitCapture(PBK_NUMOFCHANNELS, _
                                PBK_SAMPLERATE, PBK_BITNESS, _
                                PBK_BUFFERSIZEMS * PBK_SAMPLERATE, _
                                cboCaptureDevices.ListIndex) Then
        MsgBox "Error of capturing initialization", vbCritical
    End If
    
    tSound.StartProcess
    
    cmdRecording.Caption = "g"
    cmdRecording.ForeColor = vbBlack
    cboCaptureDevices.Enabled = False
    cmdPlayback.Enabled = False
    IsRecording = True
    capCount = 0
    
    Exit Sub
    
error_handler:
    
    MsgBox "Error has occured " & err.Number
    
End Sub

Private Sub Form_Load()
    Dim sName   As Variant
    
    ' // Create new TrickSound object
    Set tSound = New clsTrickSound2
    
    ' // Fill combo with available playback devices
    For Each sName In tSound.CaptureDevices
        cboCaptureDevices.AddItem sName
    Next
    
    cboCaptureDevices.ListIndex = 0
    
End Sub

Private Sub tSound_NewData( _
            ByVal DataPtr As Long, _
            ByVal CountBytes As Long)
    Dim index   As Long
    Dim total   As Long
    
    If IsRecording Then
    
        index = capCount
        capCount = capCount + (CountBytes \ PBK_NUMOFCHANNELS \ 2)
        ReDim Preserve capBuffer(PBK_NUMOFCHANNELS - 1, capCount - 1)
        
        ' // Copy captured data to buffer
        tSound.CopyData VarPtr(capBuffer(0, index)), DataPtr, CountBytes
        
        Redraw
        
    ElseIf IsPlayback Then
        
        total = (capCount - plyIndex) * PBK_NUMOFCHANNELS * 2
        
        If total > CountBytes Then
            total = CountBytes
        End If
        
        If total > 0 Then
        
            tSound.CopyData DataPtr, VarPtr(capBuffer(0, plyIndex)), total
        
            plyIndex = plyIndex + (CountBytes \ PBK_NUMOFCHANNELS \ 2)
        
        Else
            
            cmdPlayback.value = vbUnchecked
            
        End If
        
    End If
    
End Sub

' // Redraw waveform from buffer
Public Sub Redraw()
    Dim ratio       As Single
    Dim pix         As Long
    Dim index       As Long
    Dim color       As Long
    Dim iAvg        As Long
    Dim prevIndex   As Long
    Dim value       As Long
    Dim iChannel    As Long
    
    ratio = (capCount - 1) / picWaveform.ScaleWidth
    
    picWaveform.cls
    If ratio = 0 Then Exit Sub
    
    For pix = 0 To picWaveform.ScaleWidth
        
        index = pix * ratio
        
        For iAvg = prevIndex To index
        
            For iChannel = 0 To PBK_NUMOFCHANNELS - 1
                value = value + Abs(CLng(capBuffer(iChannel, iAvg)))
            Next
            
        Next
        
        value = value / (index - prevIndex + 1) / PBK_NUMOFCHANNELS
        color = RGB(value / &H80, &H100 - value / &H80, 0)
        value = value / 32768 * picWaveform.ScaleHeight / 2
        
        If value < 1 Then value = 1
        
        picWaveform.Line (pix, picWaveform.ScaleHeight / 2 - value)-(pix, picWaveform.ScaleHeight / 2 + value), color
        
        prevIndex = index
        
    Next
    
End Sub
